=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(tests)
