=== debian/changelog ===
deepin-unioncode (1.4.13-1) unstable; urgency=medium

  [ luzhen ]
  * Bug fix

  [ Deepin Packages Builder ]
  * update

 -- Deepin Packages Builder <packages@linuxdeepin.com>  Wed, 14 May 2025 13:16:16 +0800

deepin-unioncode (1.4.10) UNRELEASED; urgency=medium

  * Adapt qt6.8

 -- luzhen <luzhen@uniontech.com>  Wed, 23 Apr 2025 09:31:26 +0800

deepin-unioncode (1.4.9) UNRELEASED; urgency=medium

  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Mon, 21 Apr 2025 14:06:39 +0800

deepin-unioncode (1.4.8) stable; urgency=medium

  * bug fix

 -- luzhen <luzhen@uniontech.com>  Fri, 14 Mar 2025 09:49:16 +0800

deepin-unioncode (1.4.7) unstable; urgency=medium

  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Thu, 13 Mar 2025 17:10:00 +0800

deepin-unioncode (1.4.6) stable; urgency=medium

  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Mon, 10 Mar 2025 17:01:50 +0800

deepin-unioncode (1.4.5) unstable; urgency=medium

  * Disable smartut
  * Add model change feature
  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Thu, 27 Feb 2025 15:30:36 +0800

deepin-unioncode (1.4.4) UNRELEASED; urgency=medium

  * Adapt to qt6.8

 -- luzhen <luzhen@uniontech.com>  Fri, 21 Feb 2025 14:39:48 +0800

deepin-unioncode (1.4.1) stable; urgency=medium

  * Bug fix

 -- luzhen <luzhen@uniontech.com>  Tue, 14 Jan 2025 10:26:36 +0800

deepin-unioncode (1.4.0) unstable; urgency=medium

  * Add session manager
  * Optimize toolchain search
  * Add smart terminal

 -- luzhen <luzhen@uniontech.com>  Tue, 24 Dec 2024 10:08:37 +0800

deepin-unioncode (1.3.17) stable; urgency=medium

  * bugfix

 -- luzhen <luzhen@uniontech.com>  Thu, 14 Nov 2024 21:08:04 +0800
