=== debian/control ===
Source: deepin-unioncode
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@linuxdeepin.com>
Build-Depends:
 debhelper (>=9),
 cmake,
 qt6-base-dev,
 qt6-tools-dev-tools,
 qt6-tools-dev,
 qt6-webengine-dev,
 qt6-multimedia-dev,
 libdtk6widget-dev,
 libdtk6gui-dev,
 libdtk6core-dev,
 libkf6syntaxhighlighting-dev,
 qt6-5compat-dev,
 libqt5scripttools5 | hello,
 lxqt-build-tools (>= 0.6.0~),
 libssl-dev,
 llvm (>=1:7~),
 llvm-dev (>=1:7~),
 libclang-dev (>=1:7~),
 libutf8proc-dev,
 libmicrohttpd-dev,
 libjsoncpp-dev,
 libargtable2-dev,
 libhiredis-dev,
 catch,
 libzstd-dev,
 libjson-c-dev,
 libelf-dev,
 libcapstone-dev,
 libunwind-dev, 
 libelfin-dev,
 libdbus-1-dev,
 libxi-dev,
 clang[!mips64],
 doxygen,
 libyaml-cpp-dev,
 libcmark-dev,
 libchardet-dev,
 libuchardet-dev (>= 0.0.6),
 libicu-dev
Standards-version: 3.9.8
Homepage: http://www.deepin.org

Package: deepin-unioncode
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Recommends: cmake,
            make,
            gdb,
            g++,
            gcc,
            git,
            clangd-13|clangd,
            python3-pip
Description: IDE 'Deepin Union Code'
 Lightweight cross-platform integrated development environment

Package: libdeepin-unioncode-dev
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},deepin-unioncode
Description: IDE 'Union Code' devel library
 IDE 'Union Code' development can be carried out through this library
