## deepin-unioncode 1.4.16

=== debian/changelog ===
deepin-unioncode (1.4.16-1) unstable; urgency=medium

  [ luzhen ]
  * Bug fix

  [ Deepin Packages Builder ]
  * update

 -- Deepin Packages Builder <packages@linuxdeepin.com>  Thu, 17 Jul 2025 16:30:09 +0800
