=== debian/control ===
--- 
+++ 
@@ -5,16 +5,19 @@
 Build-Depends:
  debhelper (>=9),
  cmake,
- qt6-base-dev,
- qt6-tools-dev-tools,
- qt6-tools-dev,
- qt6-webengine-dev,
+ qt6-qmake | qt5-qmake,
+ qt6-base-dev | qtbase5-dev,
+ qt6-tools-dev-tools | qttools5-dev-tools,
+ qt6-tools-dev | qttools5-dev,
+ qt6-webengine-dev | qtwebengine5-dev,
  qt6-multimedia-dev,
- libdtk6widget-dev,
- libdtk6gui-dev,
- libdtk6core-dev,
- libkf6syntaxhighlighting-dev,
- qt6-5compat-dev,
+ libdtk6widget-dev | libdtkwidget-dev,
+ libdtk6gui-dev | libdtkgui-dev,
+ libdtk6core-dev | libdtkcore-dev,
+ libdtk6core5-bin |libdtkcore5-bin,
+ libkf6syntaxhighlighting-dev | libkf5syntaxhighlighting-dev,
+ qt6-script-dev | qtscript5-dev,
+ qt6-5compat-dev | hello,
  libqt5scripttools5 | hello,
  lxqt-build-tools (>= 0.6.0~),
  libssl-dev,
